unit ConstructUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Buttons, Menus, StdCtrls;

type
  TConstructForm = class(TForm)
    ConstructPanel: TPanel;
    ConstructMenu: TPopupMenu;
  private
    { Private declarations }
  public
    { Public declarations }
    procedure CreateConstructPanel;
    procedure ClickHandler(Sender: TObject);
    procedure CreateConstructPopup;
    procedure PopupHandler(Sender: TObject);
  end;

var
  ConstructForm: TConstructForm;

implementation

{$R *.DFM}

uses Preferences,MainUnit,Editor;

const IMARGIN = 2;
      IHEIGHT = 16;

function MakeMenuString(constr:string):string;
var str:string;
    i:integer;
begin
  str:='';
  i:=1;
  while i<= Length(constr) do
  begin
    if constr[i] = '\' then
    begin
      i:=i+2;
    end else if constr[i] = '"' then
    begin
      str:=str+'..';
      repeat i:=i+1 until constr[i] = '"';
      i:=i+1;
    end else begin
      str:=str+constr[i];
      i:=i+1;
    end;
  end;
  Result := str;
end;

procedure TConstructForm.CreateConstructPanel;
var totw:integer;                   // total width
    colh:integer;                   // height of the columns
    colw:array[1..100] of integer;  // width of the columns
    curleft:integer;                // current left position
    curtop:integer;                // current top position

    str:string;
    i,cnumb,curh,curw:integer;
    tt : TSpeedButton;
    bv : TBevel;
begin
  {Remove old contents}
  for i:= ConstructPanel.ControlCount -1 downto 0 do
    ConstructPanel.Controls[i].Free;

  {Find width and height}
  totw:=0;
  colh:=2*IMARGIN;
  for i:=1 to 100 do colw[i] := 2*IMARGIN;
  cnumb:=1;
  curh:=2*IMARGIN;
  curw:=2*IMARGIN;
  for i:=1 to constructnumb do
  begin
    str:=MakeMenuString(constructions[i]);
    if str = '|' then
    begin
      colw[cnumb] := curw;
      if colh < curh then colh := curh;
      totw := totw + curw + 2*IMARGIN;
      cnumb:=cnumb+1;
      curh:=2*IMARGIN;
      curw:=2*IMARGIN;
    end else begin
      if Canvas.TextWidth(str)+2*IMARGIN > curw then
        curw := Canvas.TextWidth(str)+2*IMARGIN;
      curh := curh + IHEIGHT;
    end;
  end;
  colw[cnumb] := curw;
  if colh < curh then colh := curh;
  totw := totw + curw + 2*IMARGIN;
  ConstructForm.ClientWidth := totw;
  ConstructForm.ClientHeight := colh;

  {Create the items}
  curtop := IMARGIN;
  curleft := IMARGIN;
  cnumb:=1;
  for i:=1 to constructnumb do
  begin
    str:=MakeMenuString(constructions[i]);
    if str = '-' then
    begin
      bv := TBevel.Create(ConstructPanel);
      bv.Style := bsLowered;
      bv.Shape := bsBottomLine;
      bv.Left := curleft - IMARGIN;
      bv.Width := colw[cnumb] + 2*IMARGIN;
      bv.Height := IHEIGHT div 2 +2;
      bv.Top := curtop;
      bv.Parent := ConstructPanel;
      curtop := curtop + IHEIGHT;
    end else if str = '|' then
    begin
      bv := TBevel.Create(ConstructPanel);
      bv.Style := bsLowered;
      bv.Shape := bsRightLine;
      bv.Left := curleft +colw[cnumb];
      bv.Width := IMARGIN+1;
      bv.Height := colh+2*IMARGIN;
      bv.Top := 0;
      bv.Parent := ConstructPanel;
      curtop := IMARGIN;
      curleft := curleft + colw[cnumb] + 2*IMARGIN;
      cnumb:=cnumb+1;
    end else begin
      tt := TSpeedButton.Create(ConstructPanel);
      tt.Caption := str;
      tt.OnClick := ClickHandler;
      tt.Left := curleft;
      tt.Width := Canvas.TextWidth(str) + 2*IMARGIN;
      tt.Top := curtop;
      tt.Height := IHEIGHT;
      tt.Flat := true;
      tt.Spacing := 0;
      tt.Tag := i;
      tt.Parent := ConstructPanel;
      curtop := curtop + IHEIGHT;
    end;
  end;
end;

procedure TConstructForm.ClickHandler(Sender: TObject);
begin
  if MainForm.ActiveMDIChild = nil then Exit;
  TEditorForm(MainForm.ActiveMDIChild).AddConstruct(TSpeedButton(Sender).Tag);
end;

{Popup menu}

procedure TConstructForm.CreateConstructPopup;
var i:integer;
    mitem:TMenuItem;
    str:string;
    vsep:boolean;
begin
  {Remove old contents}
  for i:= ConstructMenu.Items.Count-1 downto 0 do
    ConstructMenu.Items.Delete(i);
  
  vsep:=false;
  for i:=1 to constructnumb do
  begin
    str:=MakeMenuString(constructions[i]);
    if str = '|' then
    begin
      vsep := true;
    end else begin
      mitem := TMenuItem.Create(Self);
      mitem.Caption := str;
      if vsep then mitem.Break:=mbBarBreak;
      mitem.OnClick := PopUpHandler;
      if str <> '-' then mitem.Tag := i else mitem.Tag := 0;
      ConstructMenu.Items.Add(mitem);
      vsep:=false;
    end;
  end;
end;

procedure TConstructForm.PopupHandler(Sender: TObject);
begin
  if TMenuItem(Sender).Tag = 0 then Exit;
  if MainForm.ActiveMDIChild = nil then Exit;
  TEditorForm(MainForm.ActiveMDIChild).AddConstruct(TMenuItem(Sender).Tag);
end;

end.
