unit Controller;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, Buttons, ToolWin, OleCtrls, SPIRITLib_TLB;

type
  TDirectForm = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    GroupBox2: TGroupBox;
    TL0: TLabel;
    RunTask0: TSpeedButton;
    StopTask0: TSpeedButton;
    StopTask1: TSpeedButton;
    RunTask1: TSpeedButton;
    TL1: TLabel;
    StopTask2: TSpeedButton;
    RunTask2: TSpeedButton;
    TL2: TLabel;
    StopTask3: TSpeedButton;
    RunTask3: TSpeedButton;
    TL3: TLabel;
    StopTask4: TSpeedButton;
    RunTask4: TSpeedButton;
    TL4: TLabel;
    StopTask5: TSpeedButton;
    RunTask5: TSpeedButton;
    TL5: TLabel;
    StopTask6: TSpeedButton;
    RunTask6: TSpeedButton;
    TL6: TLabel;
    StopTask7: TSpeedButton;
    RunTask7: TSpeedButton;
    TL7: TLabel;
    StopTask8: TSpeedButton;
    RunTask8: TSpeedButton;
    TL8: TLabel;
    StopTask9: TSpeedButton;
    RunTask9: TSpeedButton;
    TL9: TLabel;
    StartAllBtn: TButton;
    StopAllBtn: TButton;
    SensorGroup: TGroupBox;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    SensorType0: TComboBox;
    SensorMode0: TComboBox;
    SensorType1: TComboBox;
    SensorMode1: TComboBox;
    SensorType2: TComboBox;
    SensorMode2: TComboBox;
    GroupBox3: TGroupBox;
    VariableBox: TComboBox;
    OperatorBox: TComboBox;
    ValueEdit: TEdit;
    SetBtn: TButton;
    ValueUpDown: TUpDown;
    FwdABtn: TSpeedButton;
    RevABtn: TSpeedButton;
    OffABtn: TSpeedButton;
    FloatABtn: TSpeedButton;
    SpeedA: TTrackBar;
    FwdBBtn: TSpeedButton;
    RevBBtn: TSpeedButton;
    OffBBtn: TSpeedButton;
    FloatBBtn: TSpeedButton;
    SpeedB: TTrackBar;
    FwdCBtn: TSpeedButton;
    RevCBtn: TSpeedButton;
    OffCBtn: TSpeedButton;
    FloatCBtn: TSpeedButton;
    SpeedC: TTrackBar;
    procedure SpeedAChange(Sender: TObject);
     procedure FormShow(Sender: TObject);
    procedure RunTask0Click(Sender: TObject);
    procedure StopTask0Click(Sender: TObject);
    procedure StartAllBtnClick(Sender: TObject);
    procedure StopAllBtnClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure SensorType0Change(Sender: TObject);
    procedure SensorMode0Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SetBtnClick(Sender: TObject);
    procedure FwdABtnClick(Sender: TObject);
    procedure RevABtnClick(Sender: TObject);
    procedure OffABtnClick(Sender: TObject);
    procedure FloatABtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DirectForm: TDirectForm;

implementation

{$R *.DFM}

uses MainUnit,SearchRCX;

{Dealing with the Sensors}

procedure TDirectForm.SensorType0Change(Sender: TObject);
begin
  if TComboBox(Sender).ItemIndex>=0 then
  begin
    MainForm.RCX.SetSensorType(TComboBox(Sender).Tag, TComboBox(Sender).ItemIndex);
    if TComboBox(Sender).Tag = 0 then
      MainForm.RCX.SetSensorMode(0, SensorMode0.ItemIndex,0);
    if TComboBox(Sender).Tag = 1 then
      MainForm.RCX.SetSensorMode(1, SensorMode1.ItemIndex,0);
    if TComboBox(Sender).Tag = 2 then
      MainForm.RCX.SetSensorMode(2, SensorMode2.ItemIndex,0);
  end;
end;

procedure TDirectForm.SensorMode0Change(Sender: TObject);
begin
  if TComboBox(Sender).ItemIndex>=0 then
    MainForm.RCX.SetSensorMode(TComboBox(Sender).Tag, TComboBox(Sender).ItemIndex,0);
end;


{Dealing with the Motors}

procedure TDirectForm.FwdABtnClick(Sender: TObject);
var str:string;
begin
  case TCheckBox(Sender).tag of
  0: str := '0';
  1: str := '1';
  2: str := '2';
  end;
  MainForm.RCX.SetFwd(str);
  MainForm.RCX.On_(str);
end;

procedure TDirectForm.RevABtnClick(Sender: TObject);
var str:string;
begin
  case TCheckBox(Sender).tag of
  0: str := '0';
  1: str := '1';
  2: str := '2';
  end;
  MainForm.RCX.SetRwd(str);
  MainForm.RCX.On_(str);
end;

procedure TDirectForm.OffABtnClick(Sender: TObject);
var str:string;
begin
  case TCheckBox(Sender).tag of
  0: str := '0';
  1: str := '1';
  2: str := '2';
  end;
  MainForm.RCX.Off(str);
end;

procedure TDirectForm.FloatABtnClick(Sender: TObject);
var str:string;
begin
  case TCheckBox(Sender).tag of
  0: str := '0';
  1: str := '1';
  2: str := '2';
  end;
  MainForm.RCX.Float(str);
end;

procedure TDirectForm.SpeedAChange(Sender: TObject);
var str:string;
begin
  case TTrackBar(Sender).tag of
  0: str := '0';
  1: str := '1';
  2: str := '2';
  end;
  MainForm.RCX.SetPower(str,2,TTrackBar(Sender).Position);
end;


{Dealing with the Variables}

procedure TDirectForm.SetBtnClick(Sender: TObject);
var vnumb,val:integer;
begin
  vnumb:=VariableBox.ItemIndex;
  val:=ValueUpDown.Position;
  case OperatorBox.ItemIndex of
    0: MainForm.RCX.SetVar(vnumb,2,val);
    1: MainForm.RCX.SumVar(vnumb,2,val);
    2: MainForm.RCX.SubVar(vnumb,2,val);
    3: MainForm.RCX.MulVar(vnumb,2,val);
    4: MainForm.RCX.DivVar(vnumb,2,val);
    5: MainForm.RCX.AndVar(vnumb,2,val);
    6: MainForm.RCX.OrVar(vnumb,2,val);
  end;
end;

{Dealing with the Tasks}

procedure TDirectForm.RunTask0Click(Sender: TObject);
begin
  MainForm.RCX.StartTask(TSpeedButton(Sender).Tag);
end;

procedure TDirectForm.StopTask0Click(Sender: TObject);
begin
  MainForm.RCX.StopTask(TSpeedButton(Sender).Tag);
end;

procedure TDirectForm.StartAllBtnClick(Sender: TObject);
var i:integer;
begin
  if IsMindStorms then
  begin
    for i:=0 to 9 do MainForm.RCX.StartTask(i);
  end else begin
    for i:=0 to 3 do MainForm.RCX.StartTask(i);
  end;
end;

procedure TDirectForm.StopAllBtnClick(Sender: TObject);
begin
  MainForm.RCX.StopAllTasks();
end;

procedure TDirectForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
//  if IsMindStorms then
//  begin
//    if (Key >='0') and (Key <='9') then
//      MainForm.RCX.StartTask(Ord(Key)-Ord('0'));
//  end else begin
//    if (Key >='0') and (Key <='3') then
//      MainForm.RCX.StartTask(Ord(Key)-Ord('0'));
//  end;
end;


{Handling the Window}

procedure TDirectForm.FormShow(Sender: TObject);
var ttt,i:integer;
    TC:TComboBox;
begin
  {Adapt to RCX type}
  for i:= 4 to 9 do
    begin
      TSpeedButton(FindComponent('RunTask'+IntToStr(i))).Visible := IsMindStorms;
      TSpeedButton(FindComponent('StopTask'+IntToStr(i))).Visible := IsMindStorms;
      TLabel(FindComponent('TL'+IntToStr(i))).Visible := IsMindStorms;
    end;
  if IsMindStorms then
  begin
    SensorType0.Enabled:=true;
    SensorType1.Enabled:=true;
    SensorType2.Enabled:=true;
    for i:= 0 to 2 do
    begin
      TC := TComboBox(FindComponent('SensorMode'+IntToStr(i)));
      TC.Items.Clear;
      TC.Items.Append('Raw');
      TC.Items.Append('Boolean');
      TC.Items.Append('Trans Count');
      TC.Items.Append('Period Count');
      TC.Items.Append('Percent');
      TC.Items.Append('Celsius');
      TC.Items.Append('Fahrenheit');
      TC.Items.Append('Angle');
    end;
    for i:= 0 to 2 do
    begin
      TC := TComboBox(FindComponent('SensorType'+IntToStr(i)));
      TC.Items.Clear;
      TC.Items.Append('None');
      TC.Items.Append('Switch');
      TC.Items.Append('Temperature');
      TC.Items.Append('Light');
      TC.Items.Append('Angle');
    end;
  end else begin
    SensorType0.Enabled:=false;
    SensorType1.Enabled:=false;
    SensorType2.Enabled:=false;
    for i:= 0 to 2 do
    begin
      TC := TComboBox(FindComponent('SensorMode'+IntToStr(i)));
      TC.Items.Clear;
      TC.Items.Append('Raw');
      TC.Items.Append('Boolean');
      TC.Items.Append('Trans Count');
      TC.Items.Append('Period Count');
      TC.Items.Append('Percent');
    end;
    for i:= 0 to 2 do
    begin
      TC := TComboBox(FindComponent('SensorType'+IntToStr(i)));
      TC.Items.Clear;
      TC.Items.Append('None');
      TC.Items.Append('Switch');
      TC.Items.Append('Temperature');
      TC.Items.Append('Light');
      TC.Items.Append('Angle');
      TC.Items.Append('ID0 Switch');
      TC.Items.Append('ID1 Switch');
      TC.Items.Append('ID2 Switch');
    end;
  end;
  try
    {Set the motor items}
    ttt := MainForm.RCX.Poll(3,0);
    FwdABtn.Down    :=  (ttt div 128 = 1) and ((ttt mod 16) div 8 = 1);
    RevABtn.Down    :=  (ttt div 128 = 1) and ((ttt mod 16) div 8 = 0);
    OffABtn.Down    :=  (ttt div 128 = 0) and ((ttt mod 128) div 64 = 1);
    FloatABtn.Down  :=  (ttt div 128 = 0) and ((ttt mod 128) div 64 = 0);
    SpeedA.Position := ttt mod 8;
    ttt := MainForm.RCX.Poll(3,1);
    FwdBBtn.Down    :=  (ttt div 128 = 1) and ((ttt mod 16) div 8 = 1);
    RevBBtn.Down    :=  (ttt div 128 = 1) and ((ttt mod 16) div 8 = 0);
    OffBBtn.Down    :=  (ttt div 128 = 0) and ((ttt mod 128) div 64 = 1);
    FloatBBtn.Down  :=  (ttt div 128 = 0) and ((ttt mod 128) div 64 = 0);
    SpeedB.Position := ttt mod 8;
    ttt := MainForm.RCX.Poll(3,2);
    FwdCBtn.Down    :=  (ttt div 128 = 1) and ((ttt mod 16) div 8 = 1);
    RevCBtn.Down    :=  (ttt div 128 = 1) and ((ttt mod 16) div 8 = 0);
    OffCBtn.Down    :=  (ttt div 128 = 0) and ((ttt mod 128) div 64 = 1);
    FloatCBtn.Down  :=  (ttt div 128 = 0) and ((ttt mod 128) div 64 = 0);
    SpeedC.Position := ttt mod 8;

    { Set the sensor Items }
    SensorType0.ItemIndex := MainForm.RCX.Poll(10,0);
    SensorType1.ItemIndex := MainForm.RCX.Poll(10,1);
    SensorType2.ItemIndex := MainForm.RCX.Poll(10,2);
    SensorMode0.ItemIndex := MainForm.RCX.Poll(11,0) div 32;
    SensorMode1.ItemIndex := MainForm.RCX.Poll(11,1) div 32;
    SensorMode2.ItemIndex := MainForm.RCX.Poll(11,2) div 32;
  except
    ;
  end;
end;

procedure TDirectForm.FormCreate(Sender: TObject);
var i:integer;
begin
  for i:=0 to 31 do
    VariableBox.Items.Add(Format('Var %2d',[i]));
  VariableBox.ItemIndex := 0;
  OperatorBox.ItemIndex := 0;
end;

end.
