unit DatalogUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OleCtrls, SPIRITLib_TLB;

type
  TDatalogForm = class(TForm)
    DatalogMemo: TMemo;
    UploadBtn: TButton;
    ClearBtn: TButton;
    SizeBox: TComboBox;
    Label1: TLabel;
    SaveBtn: TButton;
    SaveDialog1: TSaveDialog;
    procedure UploadBtnClick(Sender: TObject);
    procedure ClearBtnClick(Sender: TObject);
    procedure SizeBoxChange(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DatalogForm: TDatalogForm;

implementation

uses MainUnit, Preferences;

{$R *.DFM}

procedure TDatalogForm.UploadBtnClick(Sender: TObject);
var updata:OLEVariant;
    size,i,st,num:integer;
    str:string;
begin
  updata := MainForm.RCX.UploadDatalog(0,1);
  size := updata[2,0] - 1;
  st := 1;
  DatalogMemo.Lines.Clear;
  while size > 0 do
  begin
    if size>50 then num := 50 else num:=size;
    updata := MainForm.RCX.UploadDatalog(st,num);
    for i:=0 to num-1 do
    begin
      str:='UNKNOWN';
      case updata[0,i] of
         0: str:='Variable';
         1: str:='   Timer';
         9: str:='  Sensor';
        14: str:='   Watch';
      end;
      DatalogMemo.Lines.Add(
        Format(str+' %2d: %7d',[Integer(updata[1,i]),Integer(updata[2,i])])
      );
    end;
    size:=size-num;
    st:=st+num;
  end;
end;

procedure TDatalogForm.ClearBtnClick(Sender: TObject);
begin
  MainForm.RCX.SetDatalog(0);
  SizeBox.Text := '0';
end;

procedure TDatalogForm.SizeBoxChange(Sender: TObject);
begin
  MainForm.RCX.SetDatalog(StrToIntDef(SizeBox.Text,0));
end;

procedure TDatalogForm.SaveBtnClick(Sender: TObject);
begin
  if SaveDialog1.Execute() then
  begin
    DatalogMemo.Lines.SaveToFile(SaveDialog1.FileName);
  end;

end;

end.
