unit Diagnose;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Mask;

type
  TDiagForm = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Alive: TPanel;
    Label2: TLabel;
    Version: TPanel;
    ttt: TLabel;
    RefreshBtn: TButton;
    Label3: TLabel;
    Port: TPanel;
    IRGroup: TGroupBox;
    IRShort: TRadioButton;
    IRLong: TRadioButton;
    Label4: TLabel;
    ProgramNumb: TPanel;
    WatchGroup: TGroupBox;
    Label6: TLabel;
    CurrentBtn: TButton;
    Watch: TPanel;
    DisplayGroup: TGroupBox;
    DisplayType: TComboBox;
    PowerGroup: TGroupBox;
    Label5: TLabel;
    PowerDown: TEdit;
    BatStatus: TPanel;
    procedure FormShow(Sender: TObject);
    procedure RefreshBtnClick(Sender: TObject);
    procedure IRShortClick(Sender: TObject);
    procedure IRLongClick(Sender: TObject);
    procedure CurrentBtnClick(Sender: TObject);
    procedure DisplayTypeChange(Sender: TObject);
    procedure PowerDownChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DiagForm: TDiagForm;

implementation

{$R *.DFM}

uses MainUnit, Controller, SearchRCX, Preferences;

procedure TDiagForm.FormShow(Sender: TObject);
begin
  DisplayGroup.Visible := IsMindStorms;
  WatchGroup.Visible := IsMindStorms;
  IRGroup.Visible := IsMindStorms;
  RefreshBtnClick(Self);
  if IsMindStorms then
    if IRShort.Checked then
      MainForm.RCX.PBTxPower(0)
    else
      MainForm.RCX.PBTxPower(1);
end;

procedure TDiagForm.RefreshBtnClick(Sender: TObject);
var w:integer;
begin
  Port.Caption:= Format('COM%d',[MainForm.RCX.ComPortNo]);
  if MainForm.RCX.PBAliveOrNot then
  begin
    Alive.Caption := 'RCX is alive';
    try
      BatStatus.Caption := Format('%d mV',[MainForm.RCX.PBBattery()]);
    except
      BatStatus.Caption := '---';
    end;
    Version.Caption := MainForm.RCX.UnlockPBrick();
    if IsMindStorms then
    begin
      try
        ProgramNumb.Caption := Format('%d',[1+MainForm.RCX.Poll(8,0)]);
      except
        ProgramNumb.Caption := '---';
      end;
      try
        w:= MainForm.RCX.Poll(14,0);
        Watch.Caption := Format('%d:%d',[w div 60,w mod 60]);
      except
        Watch.Caption := '00:00';
      end;
    end else begin
      ProgramNumb.Caption := '---';
      Watch.Caption := '---';
    end;
  end else begin
    Alive.Caption := 'RCX is NOT alive';
    BatStatus.Caption := '---';
    Version.Caption := '---';
    ProgramNumb.Caption := '---';
    Watch.Caption := '00:00';
  end;
end;

procedure TDiagForm.IRShortClick(Sender: TObject);
begin
    MainForm.RCX.PBTxPower(0);
end;

procedure TDiagForm.IRLongClick(Sender: TObject);
begin
    MainForm.RCX.PBTxPower(1);
end;

procedure TDiagForm.CurrentBtnClick(Sender: TObject);
var Present: TDateTime;
    Hour, Min, Sec, MSec: Word;
  begin
  Present:= Now;
  DecodeTime(Present, Hour, Min, Sec, MSec);
  Watch.Caption:= Format('%d:%d',[Hour,Min]);
  MainForm.RCX.SetWatch(Hour,Min);
end;

procedure TDiagForm.DisplayTypeChange(Sender: TObject);
begin
  MainForm.RCX.SelectDisplay(2,DisplayType.ItemIndex);
end;

procedure TDiagForm.PowerDownChange(Sender: TObject);
begin
  MainForm.RCX.PBPowerDownTime(StrtoInt(PowerDown.Text));
end;

end.
