unit ExecProgram;

{ This unit contains two routines to execute a program
  from a Delpi application. The first one immediately
  returns, the second waits for completion of the program.
  Both get two arguments, the string to execute, and the
  window type of the program (use SW_NORMAL in most cases).
}

interface

uses Windows, Messages, ShellApi;

function ExecuteAndContinue( Path: Pchar; Visibility: word ): dword;

function ExecuteAndWait( Path: Pchar; Visibility: word ): dword;

implementation

function ExecuteAndContinue( Path: Pchar; Visibility: word ): dword;
begin
  ExecuteAndContinue := WinExec(Path,Visibility);
end;

function ExecuteAndWait( Path: Pchar; Visibility: word ): dword;
var bStat: BOOL;
    pi: TProcessInformation;
    si: TStartupInfo;
    iExit: DWORD;
begin
  FillMemory( @si, sizeof( TStartupInfo ), 0 );
  with si do
    begin
    cb := sizeof( TStartupInfo );
    dwFlags := STARTF_USESHOWWINDOW;
    wShowWindow := Visibility;
    end;

  bStat := CreateProcess
    (
    nil,                    // address of module name
    Path,                   // address of command line
    nil,                    // address of process security attributes
    nil,                    // address of thread security attributes
    false,                  // new process inherits handles
    NORMAL_PRIORITY_CLASS,  // creation flags
    nil,                    // address of new environment block
    nil,                    // address of current directory name
    si,                     // address of STARTUPINFO
    pi                      // address of PROCESS_INFORMATION
    );
  if not bstat then begin Result := dword(-1); Exit; end;
  repeat
    GetExitCodeProcess( pi.hProcess, iExit );
  until (iExit <> STILL_ACTIVE);
  CloseHandle( pi.hProcess );
  CloseHandle( pi.hThread );
  Result := iExit;
end;

end.
