unit MemoryUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OleCtrls, SPIRITLib_TLB;

type
  TMemoryForm = class(TForm)
    MemoryMemo: TMemo;
    RefreshBtn: TButton;
    procedure RefreshBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MemoryForm: TMemoryForm;

implementation

uses MainUnit, Preferences, SearchRCX;

{$R *.DFM}

procedure TMemoryForm.RefreshBtnClick(Sender: TObject);
var memdata:OLEVariant;
    i,j:integer;
    str:string;
begin
  memdata := MainForm.RCX.MemMap();
  MemoryMemo.Lines.Clear;
  if IsMindStorms then
  begin
    MemoryMemo.Lines.Add('Subroutine Pointers');
    for i:=0 to 4 do
    begin
      str := Format('P%d:',[i+1]);
      for j:=0 to 7 do str:=str+Format('%6d',[Integer(memdata[1+8*i+j])]);
      MemoryMemo.Lines.Add(str);
    end;
    MemoryMemo.Lines.Add('');
    MemoryMemo.Lines.Add('Task Pointers');
    for i:=0 to 4 do
    begin
      str := Format('P%d:',[i+1]);
      for j:=0 to 9 do str:=str+Format('%6d',[Integer(memdata[41+10*i+j])]);
      MemoryMemo.Lines.Add(str);
    end;
    MemoryMemo.Lines.Add('');
    MemoryMemo.Lines.Add(Format('Datalog Start Pointer:   %6d',[Integer(memdata[91])]));
    MemoryMemo.Lines.Add(Format('Datalog Current Pointer: %6d',[Integer(memdata[92])]));
    MemoryMemo.Lines.Add(Format('Total Memory Used:       %6d',[Integer(memdata[93])]));
    MemoryMemo.Lines.Add(Format('Top of Memory:           %6d',[Integer(memdata[94])]));
    MemoryMemo.Lines.Add(Format('Free Memory Left:        %6d',[Integer(memdata[94])-Integer(memdata[93])]));
  end else begin
    MemoryMemo.Lines.Add('Subroutine Pointers');
    str:='';
    for j:=0 to 3 do str:=str+Format('%6d',[Integer(memdata[1+j])]);
    MemoryMemo.Lines.Add(str);
    MemoryMemo.Lines.Add('');
    MemoryMemo.Lines.Add('Task Pointers');
    str:='';
    for j:=0 to 3 do str:=str+Format('%6d',[Integer(memdata[5+j])]);
    MemoryMemo.Lines.Add(str);
    MemoryMemo.Lines.Add('');
    MemoryMemo.Lines.Add(Format('Total Memory Used: %6d',[Integer(memdata[9])]));
    MemoryMemo.Lines.Add(Format('Top of Memory:     %6d',[Integer(memdata[10])]));
    MemoryMemo.Lines.Add(Format('Free Memory Left:  %6d',[Integer(memdata[10])-Integer(memdata[9])]));
  end;
end;

procedure TMemoryForm.FormShow(Sender: TObject);
begin
  RefreshBtnClick(Self);
end;

end.
