unit Preferences;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Buttons;

type
  TPrefForm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    StartupDefault: TButton;
    StartupOK: TButton;
    StartupCancel: TButton;
    GroupBox2: TGroupBox;
    CheckShowForm: TRadioButton;
    CheckConnect: TRadioButton;
    CheckNoConnect: TRadioButton;
    ComBox: TGroupBox;
    Panel1: TPanel;
    CheckMindStorms: TRadioButton;
    CheckCyberMaster: TRadioButton;
    Panel2: TPanel;
    CheckAutomatic: TRadioButton;
    CheckCOM1: TRadioButton;
    CheckCOM2: TRadioButton;
    CheckCOM3: TRadioButton;
    CheckCOM4: TRadioButton;
    Bevel2: TBevel;
    TabSheet3: TTabSheet;
    GroupBox3: TGroupBox;
    CheckSavePos: TCheckBox;
    GeneralDefault: TButton;
    GeneralOK: TButton;
    GeneralCancel: TButton;
    CheckShowRecent: TCheckBox;
    CheckSaveBackup: TCheckBox;
    TabSheet2: TTabSheet;
    GroupBox1: TGroupBox;
    CheckColorCoding: TCheckBox;
    CheckShowConstructions: TCheckBox;
    EditorCancel: TButton;
    EditorOK: TButton;
    EditorDefault: TButton;
    CheckShowToolbar: TCheckBox;
    CheckShowStatusbar: TCheckBox;
    FontDialog1: TFontDialog;
    FontBtn: TButton;
    TabSheet4: TTabSheet;
    GroupBox4: TGroupBox;
    TemplatesList: TListBox;
    TemplatesOK: TButton;
    TemplatesCancel: TButton;
    InsertBtn: TButton;
    DeleteBtn: TButton;
    UpBtn: TBitBtn;
    DownBtn: TBitBtn;
    ChangeBtn: TButton;
    TabSheet5: TTabSheet;
    GroupBox5: TGroupBox;
    MacrosList: TListBox;
    MDelete: TButton;
    MChange: TButton;
    MacrosOK: TButton;
    MacrosCancel: TButton;
    MShift: TCheckBox;
    ShiftMacrosList: TListBox;
    CheckAutoIndentCode: TCheckBox;
    CheckMacrosOn: TCheckBox;
    CheckCompatibility: TCheckBox;
    TemplatesDefault: TButton;
    MacrosDefault: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure StartupDefaultClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CheckConnectClick(Sender: TObject);
    procedure GeneralDefaultClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure EditorDefaultClick(Sender: TObject);
    procedure FontBtnClick(Sender: TObject);
    procedure UpBtnClick(Sender: TObject);
    procedure DownBtnClick(Sender: TObject);
    procedure ChangeBtnClick(Sender: TObject);
    procedure InsertBtnClick(Sender: TObject);
    procedure DeleteBtnClick(Sender: TObject);
    procedure TemplatesListDblClick(Sender: TObject);
    procedure MShiftClick(Sender: TObject);
    procedure MDeleteClick(Sender: TObject);
    procedure MChangeClick(Sender: TObject);
    procedure ShiftMacrosListDblClick(Sender: TObject);
    procedure TemplatesDefaultClick(Sender: TObject);
    procedure MacrosDefaultClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PrefForm: TPrefForm;

procedure LoadAllValues;
procedure SaveAllValues;


{Joystick settings}
var LeftRight:boolean;              // Whether in left-right mode
    LeftMotor:integer;              // the left motor
    RightMotor:integer;             // the right motor
    LeftReversed:boolean;           // whether left must be reversed
    RightReversed:boolean;          // whether right must be reversed
    MotorSpeed:integer;             // speed of the motors

{Macros}
const MAXMACRO = 200;
var macros:array[1..MAXMACRO] of string;
    macronumb:integer;
    MacrosChanged:boolean;

{Constructions}
const MAXCONSTRUCT = 200;
var constructions:array[1..MAXCONSTRUCT] of string;
    constructnumb:integer;
    ShowConstructForm:boolean;
    ShowConstructPopup:boolean;
    ConstructionsChanged:boolean;

{Keywords}
const MAXKEY = 100;
      MAXCOM = 100;
      MAXCONST = 100;
var cc_keywords:array[1..MAXKEY] of string;
    cc_keynumb:integer;
    cc_commands:array[1..MAXCOM] of string;
    cc_commandnumb:integer;
    cc_constants:array[1..MAXCONST] of string;
    cc_constantnumb:integer;

{Recent Files}
procedure AddRecentFile(str:string);
const MAXRECENT = 4;
var RecentFiles : array [1..4] of string;

{Startup}
const
  SU_SHOWFORM = 0;
  SU_CONNECT = 1;
  SU_NOCONNECT = 2;
  SU_MINDSTORMS = 0;
  SU_CYBERMASTER = 1;
var
  StartupAction:integer;     // Action to take at startup
  RCXType:integer;           // Mindstorms (0) or Cybermaster (1)
  COMPort:integer;           // Number of the default COM port (0=automatic)

{Colors}
var
  BackgroundColor:TColor;    // Background color in editor
const MAXCC = 20;
const CC_NORMAL      = 1;
      CC_COMMENTL    = 2;
      CC_COMMENTS    = 3;
      CC_KEYWORD     = 4;
      CC_DEFINE      = 5;
      CC_DEFINEKEY   = 6;
      CC_COMMAND     = 7;
      CC_DEFINECOM   = 8;
      CC_CONSTANT    = 9;
      CC_DEFINECONST = 10;
      CC_FIELD       = 11;
var cc_color:array[1..MAXCC] of TColor;
    cc_style:array[1..MAXCC] of TFontStyles;

{Editor}
var
  ColorCoding:boolean;       // Whether to use color coding
  ColorCodingChanged:boolean;// Whether ColorCoding was changed
  FontName:string;           // Name of the font
  FontSize:integer;          // Size of the font
  FontChanged:boolean;       // Whether the font changed
  AutoIndentCode:boolean;    // Whether to automatically indent code
  MacrosOn:boolean;          // Whether macro's can be used

{General}
var
  SaveWindowPos:boolean;     // Whether to save window positions
  ShowRecent:boolean;        // Whether to show recent files
  ShowRecentChanged:boolean; // Whether ShowRecent was changed
  SaveBackup:boolean;        // Whether to save backups of existing files
  ShowToolbar:boolean;       // Whether to show the toolbar
  ShowStatusbar:boolean;     // Whether to show the statusbar
  CompatibilityMode:boolean; // Whether nqc 1.x compatible

implementation

uses registry,
     MainUnit, Diagnose, Controller, Watch, Piano, ConstructUnit,
     JoystickUnit, DatalogUnit, TransmitUnit, MemoryUnit, CodeUnit,
  MessageUnit;

{$R *.DFM}

{**************************************************
  Registry stuff
 **************************************************}

var reg: TRegistry;    // The registry
    mainkey: string = '\Software\RcxCC\version 3.0';

procedure Reg_Init;
begin
  reg := TRegistry.Create;
end;

procedure Reg_OpenKey(name:string);
{Opens the registry key}
begin
  reg.OpenKey(mainkey+'\'+name,true);
end;

procedure Reg_DeleteKey(name:string);
{Deletes the registry key}
begin
  reg.DeleteKey(mainkey+'\'+name);
end;

procedure Reg_CloseKey;
{Closes the current key.}
begin
  reg.CloseKey;
end;

function Reg_KeyExists(name:string):boolean;
begin
  Result := reg.KeyExists(mainkey+'\'+name);
end;

function Reg_ValueExists(name:string):boolean;
begin
  Result := reg.ValueExists(name);
end;

{-- Booleans --}

procedure Reg_WriteBool(name:string; val:boolean);
{Writes a boolean value to the registry}
begin
  reg.WriteBool(name,val);
end;

function Reg_ReadBool(name:string; def:boolean):boolean;
{Read a boolean value from the registry. Returns the
 default when it does not exist.}
begin
  if reg.ValueExists(name) then
    Reg_ReadBool := reg.ReadBool(name)
  else
    Reg_ReadBool := def;
end;

{-- Integers --}

procedure Reg_WriteInteger(name:string; val:integer);
{Writes a integer value to the registry}
begin
  reg.WriteInteger(name,val);
end;

function Reg_ReadInteger(name:string; def:integer):integer;
{Read a integer value from the registry. Returns the
 default when it does not exist.}
begin
  if reg.ValueExists(name) then
    Reg_ReadInteger := reg.ReadInteger(name)
  else
    Reg_ReadInteger := def;
end;

{-- Strings --}

procedure Reg_WriteString(name:string; val:string);
{Writes a string value to the registry}
begin
  reg.WriteString(name,val);
end;

function Reg_ReadString(name:string; def:string):string;
{Read a string value from the registry. Returns the
 default when it does not exist.}
begin
  if reg.ValueExists(name) then
    Reg_ReadString := reg.ReadString(name)
  else
    Reg_ReadString := def;
end;

{-- Styles --}

procedure Reg_WriteStyle(name:string; val:TFontStyles);
{Writes a style value to the registry}
var tt:integer;
begin
  tt := 0;
  if fsBold in val then tt := tt+1;
  if fsItalic in val then tt := tt+2;
  reg.WriteInteger(name,tt);
end;

function Reg_ReadStyle(name:string; def:TFontStyles):TFontStyles;
{Read a style value from the registry. Returns the
 default when it does not exist.}
var tt:integer;
begin
  if reg.ValueExists(name) then
  begin
    tt := reg.ReadInteger(name);
    Result := [];
    if (tt and 1) > 0 then Result := Result + [fsBold];
    if (tt and 2) > 0 then Result := Result + [fsItalic];
  end
  else
    Result := def;
end;

{-- Colors --}

procedure Reg_WriteColor(name:string; val:TColor);
{Writes a color value to the registry}
begin
  reg.WriteInteger(name,integer(val));
end;

function Reg_ReadColor(name:string; def:TColor):TColor;
{Read a color value from the registry. Returns the
 default when it does not exist.}
begin
  if reg.ValueExists(name) then
    Result := TColor(reg.ReadInteger(name))
  else
    Result := def;
end;

{**************************************************
  Reading and writing the registry
 **************************************************}

function MyIntToStr(val:integer):string;
begin
  Result := IntToStr(val div 100) +
            IntToStr((val mod 100) div 10) +
            IntToStr(val mod 10);
end;

{Macros}

procedure LoadMacroValues;
{Loads the macro values from the registry}
var i:integer;
    f:TextFile;
begin
  if not Reg_KeyExists('Macros') then
  begin
    AssignFile(f,ExtractFilePath(Application.ExeName)+'Default\macros.txt');
    ReSet(f);
    macronumb := 0;
    while not Eof(f) do
    begin
      macronumb:=macronumb+1;
      ReadLn(f,macros[macronumb]);
    end;
    CloseFile(f);
    Exit;
  end;
  Reg_OpenKey('Macros');
  i:=1;
  while reg.ValueExists('Macro'+MyIntToStr(i)) do
  begin
    macros[i] := Reg_ReadString('Macro'+MyIntToStr(i),'');
    i := i+1;
  end;
  macronumb := i-1;
  Reg_CloseKey;
end;

procedure SaveMacroValues;
{Saves the macro values to the registry}
var i:integer;
begin
  Reg_DeleteKey('Macros');
  Reg_OpenKey('Macros');
  for i:=1 to macronumb do
    Reg_WriteString('Macro'+MyIntToStr(i),macros[i]);
  Reg_CloseKey;
end;

procedure ResetMacroValues;
{Resets the macro values to default}
begin
  Reg_DeleteKey('Macros');
  LoadMacroValues;
end;

{Constructions}

procedure LoadConstructionValues;
{Loads the construction values from the registry}
var i:integer;
    f:TextFile;
begin
  if not Reg_KeyExists('Templates') then
  begin
    AssignFile(f,ExtractFilePath(Application.ExeName)+'Default\templates.txt');
    ReSet(f);
    constructnumb := 0;
    while not Eof(f) do
    begin
      constructnumb:=constructnumb+1;
      ReadLn(f,constructions[constructnumb]);
    end;
    CloseFile(f);
    Exit;
  end;
  Reg_OpenKey('Templates');
  i:=1;
  while Reg_ValueExists('Template'+MyIntToStr(i)) do
  begin
    constructions[i] := Reg_ReadString('Template'+MyIntToStr(i),'');
    i := i+1;
  end;
  constructnumb := i-1;
  Reg_CloseKey;
end;

procedure SaveConstructionValues;
{Saves the construction values to the registry}
var i:integer;
begin
  Reg_DeleteKey('Templates');
  Reg_OpenKey('Templates');
  for i:=1 to constructnumb do
    Reg_WriteString('Template'+MyIntToStr(i),constructions[i]);
  Reg_CloseKey;
end;

procedure ResetConstructionValues;
{Resets the construction values to default}
begin
  Reg_DeleteKey('Templates');
  LoadConstructionValues;
end;

{Keywords for Colorcoding}

procedure LoadKeywordValues;
{Loads the keyword values from the registry}
var i:integer;
    f:TextFile;
begin
  if not Reg_KeyExists('Macros') then
  begin
    AssignFile(f,ExtractFilePath(Application.ExeName)+'Default\keywords.txt');
    ReSet(f);
    cc_keynumb := 0;
    while not Eof(f) do
    begin
      cc_keynumb:=cc_keynumb+1;
      ReadLn(f,cc_keywords[cc_keynumb]);
    end;
    CloseFile(f);

    AssignFile(f,ExtractFilePath(Application.ExeName)+'Default\commands.txt');
    ReSet(f);
    cc_commandnumb := 0;
    while not Eof(f) do
    begin
      cc_commandnumb:=cc_commandnumb+1;
      ReadLn(f,cc_commands[cc_commandnumb]);
    end;
    CloseFile(f);

    AssignFile(f,ExtractFilePath(Application.ExeName)+'Default\constants.txt');
    ReSet(f);
    cc_constantnumb := 0;
    while not Eof(f) do
    begin
      cc_constantnumb:=cc_constantnumb+1;
      ReadLn(f,cc_constants[cc_constantnumb]);
    end;
    CloseFile(f);

    Exit;
  end;
  Reg_OpenKey('Keywords');
  i:=1;
  while Reg_ValueExists('Keyword'+MyIntToStr(i)) do
  begin
    cc_keywords[i] := Reg_ReadString('Keyword'+MyIntToStr(i),'');
    i := i+1;
  end;
  cc_keynumb := i-1;
  Reg_CloseKey;
  Reg_OpenKey('Commands');
  i:=1;
  while Reg_ValueExists('Command'+MyIntToStr(i)) do
  begin
    cc_commands[i] := Reg_ReadString('Command'+MyIntToStr(i),'');
    i := i+1;
  end;
  cc_commandnumb := i-1;
  Reg_CloseKey;
  Reg_OpenKey('Constants');
  i:=1;
  while Reg_ValueExists('Constant'+MyIntToStr(i)) do
  begin
    cc_constants[i] := Reg_ReadString('Constant'+MyIntToStr(i),'');
    i := i+1;
  end;
  cc_constantnumb := i-1;
  Reg_CloseKey;
end;

procedure SaveKeywordValues;
{Saves the keyword values to the registry}
var i:integer;
begin
  Reg_DeleteKey('Keywords');
  Reg_OpenKey('Keywords');
  for i:=1 to cc_keynumb do
    Reg_WriteString('Keyword'+MyIntToStr(i),cc_keywords[i]);
  Reg_CloseKey;
  Reg_DeleteKey('Commands');
  Reg_OpenKey('Commands');
  for i:=1 to cc_commandnumb do
    Reg_WriteString('Command'+MyIntToStr(i),cc_commands[i]);
  Reg_CloseKey;
  Reg_DeleteKey('Constants');
  Reg_OpenKey('Constants');
  for i:=1 to cc_constantnumb do
    Reg_WriteString('Constant'+MyIntToStr(i),cc_constants[i]);
  Reg_CloseKey;
end;

procedure ResetKeywordValues;
{Resets the keyword values to default}
begin
  Reg_DeleteKey('Keywords');
  Reg_DeleteKey('Commands');
  Reg_DeleteKey('Constants');
  LoadKeywordValues;
end;

{ The Recent Files Information}

procedure AddRecentFile(str:string);
var i:integer;
begin
  for i:=1 to MAXRECENT do
    if RecentFiles[i] = str then Exit;
  for i:= MAXRECENT downto 2 do
    RecentFiles[i] := RecentFiles[i-1];
  RecentFiles[1] := str;
end;

procedure LoadRecentValues;
{Loads the recent files values from the registry}
var i:integer;
begin
  Reg_OpenKey('Recent Files');
  for i:=1 to MAXRECENT do
    RecentFiles[i] := Reg_ReadString('RecentFiles'+MyIntToStr(i),'');
  Reg_CloseKey;
end;

procedure SaveRecentValues;
{Saves the recent files values in the registry}
var i:integer;
begin
  Reg_DeleteKey('Recent Files');
  Reg_OpenKey('Recent Files');
  for i:=1 to MAXRECENT do
    Reg_WriteString('RecentFiles'+MyIntToStr(i),RecentFiles[i]);
  Reg_CloseKey;
end;

procedure ResetRecentValues;
{Resets the recent values to default}
begin
  Reg_DeleteKey('Recent Files');
  LoadRecentValues;
end;

procedure LoadWindowsValues;
{Loads the windows values from the registry}
begin
  Reg_OpenKey('Windows');
  MainForm.Left := Reg_ReadInteger('XMainWindow',100);
  MainForm.Top := Reg_ReadInteger('YMainWindow',10);
  MainForm.Width := Reg_ReadInteger('WMainWindow',600);
  MainForm.Height := Reg_ReadInteger('HMainWindow',450);
  DiagForm.Left := Reg_ReadInteger('XDiagWindow',30);
  DiagForm.Top := Reg_ReadInteger('YDiagWindow',30);
  DirectForm.Left := Reg_ReadInteger('XDirectWindow',50);
  DirectForm.Top := Reg_ReadInteger('YDirectWindow',50);
  WatchForm.Left := Reg_ReadInteger('XWatchWindow',70);
  WatchForm.Top := Reg_ReadInteger('YWatchWindow',70);
  PianoForm.Left := Reg_ReadInteger('XPianoWindow',90);
  PianoForm.Top := Reg_ReadInteger('YPianoWindow',90);
  ConstructForm.Left := Reg_ReadInteger('XTemplateWindow',10);
  ConstructForm.Top := Reg_ReadInteger('YTemplateWindow',10);
  JoystickForm.Left := Reg_ReadInteger('XJoystickWindow',100);
  JoystickForm.Top := Reg_ReadInteger('YJoyStickWindow',100);
  DatalogForm.Left := Reg_ReadInteger('XDatalogWindow',110);
  DatalogForm.Top := Reg_ReadInteger('YDatalogWindow',110);
  TransmitForm.Left := Reg_ReadInteger('XTransmitWindow',120);
  TransmitForm.Top := Reg_ReadInteger('YTransmitWindow',120);
  MemoryForm.Left := Reg_ReadInteger('XMemoryWindow',130);
  MemoryForm.Top := Reg_ReadInteger('YMemoryWindow',130);
  CodeForm.Left := Reg_ReadInteger('XCodeWindow',140);
  CodeForm.Top := Reg_ReadInteger('YCodeWindow',140);
  CodeForm.Width := Reg_ReadInteger('WCodeWindow',500);
  CodeForm.Height := Reg_ReadInteger('HCodeWindow',340);
  MessageForm.Left := Reg_ReadInteger('XMessageWindow',150);
  MessageForm.Top := Reg_ReadInteger('YMessageWindow',150);
  Reg_CloseKey;
end;

procedure SaveWindowsValues;
{Saves the windows values in the registry}
begin
  Reg_DeleteKey('Windows');
  if not SaveWindowPos then Exit;
  Reg_OpenKey('Windows');
  Reg_WriteInteger('XMainWindow',MainForm.Left);
  Reg_WriteInteger('YMainWindow',MainForm.Top);
  Reg_WriteInteger('WMainWindow',MainForm.Width);
  Reg_WriteInteger('HMainWindow',MainForm.Height);
  Reg_WriteInteger('XDiagWindow',DiagForm.Left);
  Reg_WriteInteger('YDiagWindow',DiagForm.Top);
  Reg_WriteInteger('XDirectWindow',DirectForm.Left);
  Reg_WriteInteger('YDirectWindow',DirectForm.Top);
  Reg_WriteInteger('XWatchWindow',WatchForm.Left);
  Reg_WriteInteger('YWatchWindow',WatchForm.Top);
  Reg_WriteInteger('XPianoWindow',PianoForm.Left);
  Reg_WriteInteger('YPianoWindow',PianoForm.Top);
  Reg_WriteInteger('XTemplateWindow',ConstructForm.Left);
  Reg_WriteInteger('YTemplateWindow',ConstructForm.Top);
  Reg_WriteInteger('XJoystickWindow',JoystickForm.Left);
  Reg_WriteInteger('YJoystickWindow',JoystickForm.Top);
  Reg_WriteInteger('XDatalogWindow',DatalogForm.Left);
  Reg_WriteInteger('YDatalogWindow',DatalogForm.Top);
  Reg_WriteInteger('XTransmitWindow',TransmitForm.Left);
  Reg_WriteInteger('YTransmitWindow',TransmitForm.Top);
  Reg_WriteInteger('XMemoryWindow',MemoryForm.Left);
  Reg_WriteInteger('YMemoryWindow',MemoryForm.Top);
  Reg_WriteInteger('XCodeWindow',CodeForm.Left);
  Reg_WriteInteger('YCodeWindow',CodeForm.Top);
  Reg_WriteInteger('WCodeWindow',CodeForm.Width);
  Reg_WriteInteger('HCodeWindow',CodeForm.Height);
  Reg_WriteInteger('XMessageWindow',MessageForm.Left);
  Reg_WriteInteger('YMessageWindow',MessageForm.Top);
  Reg_CloseKey;
end;

procedure ResetWindowsValues;
{Resets the windows values to default}
begin
  Reg_DeleteKey('Windows');
  LoadWindowsValues;
end;

procedure LoadJoystickValues;
{Loads the joystick values from the registry}
begin
  Reg_OpenKey('Joystick');
  LeftRight := Reg_ReadBool('LeftRight',true);
  LeftMotor := Reg_ReadInteger('LeftMotor',0);
  RightMotor := Reg_ReadInteger('RightMotor',2);
  LeftReversed := Reg_ReadBool('LeftReversed',false);
  RightReversed := Reg_ReadBool('RightReversed',false);
  MotorSpeed := Reg_ReadInteger('MotorSpeed',4);
  Reg_CloseKey;
end;

procedure SaveJoystickValues;
{Saves the joystick values to the registry}
begin
  Reg_DeleteKey('Joystick');
  Reg_OpenKey('Joystick');
  Reg_WriteBool('LeftRight',LeftRight);
  Reg_WriteInteger('LeftMotor',LeftMotor);
  Reg_WriteInteger('RightMotor',RightMotor);
  Reg_WriteBool('LeftReversed',LeftReversed);
  Reg_WriteBool('RightReversed',RightReversed);
  Reg_WriteInteger('MotorSpeed',MotorSpeed);
  Reg_CloseKey;
end;

procedure ResetJoystickValues;
{Resets the joystick values to default}
begin
  Reg_DeleteKey('Joystick');
  LoadJoystickValues;
end;

procedure LoadColorValues;
{Loads the color values from the registry}
begin
  Reg_OpenKey('Colors');
  BackgroundColor := Reg_ReadColor('BackgroundColor',clWhite);

  cc_color[CC_NORMAL] := Reg_ReadColor('NormalColor',clBlack);
  cc_color[CC_COMMENTS] := Reg_ReadColor('CommentColor',clGreen);
  cc_color[CC_COMMENTL] := cc_color[CC_COMMENTS]+1;
  cc_color[CC_KEYWORD] := Reg_ReadColor('KeywordColor',clBlack);
  cc_color[CC_COMMAND] := Reg_ReadColor('CommandColor',clBlue);
  cc_color[CC_CONSTANT] := Reg_ReadColor('ConstantColor',clBlue);
  cc_color[CC_DEFINE] := Reg_ReadColor('DefineColor',clMaroon);
  cc_color[CC_DEFINEKEY] := Reg_ReadColor('DefineKeywordColor',clMaroon);
  cc_color[CC_DEFINECOM] := Reg_ReadColor('DefineCommandColor',clNavy);
  cc_color[CC_DEFINECONST] := Reg_ReadColor('DefineConstantColor',clNavy);
  cc_color[CC_FIELD] := Reg_ReadColor('FieldColor',clRed);

  cc_style[CC_NORMAL] := Reg_ReadStyle('NormalStyle',[]);
  cc_style[CC_COMMENTS] := Reg_ReadStyle('CommentStyle',[fsItalic]);
  cc_style[CC_COMMENTL] := cc_style[CC_COMMENTS];
  cc_style[CC_KEYWORD] := Reg_ReadStyle('KeywordStyle',[fsBold]);
  cc_style[CC_COMMAND] := Reg_ReadStyle('CommandStyle',[]);
  cc_style[CC_CONSTANT] := Reg_ReadStyle('ConstantStyle',[]);
  cc_style[CC_DEFINE] := Reg_ReadStyle('DefineStyle',[]);
  cc_style[CC_DEFINEKEY] := Reg_ReadStyle('DefineKeywordStyle',[fsBold]);
  cc_style[CC_DEFINECOM] := Reg_ReadStyle('DefineCommandStyle',[]);
  cc_style[CC_DEFINECONST] := Reg_ReadStyle('DefineConstantStyle',[]);
  cc_style[CC_FIELD] := Reg_ReadStyle('FieldStyle',[fsItalic]);
  Reg_CloseKey;
end;

procedure SaveColorValues;
{Saves the color values in the registry}
begin
  Reg_DeleteKey('Colors');
  Reg_OpenKey('Colors');
  Reg_WriteColor('BackgroundColor',BackgroundColor);

  Reg_WriteColor('NormalColor',cc_color[CC_NORMAL]);
  Reg_WriteColor('CommentColor',cc_color[CC_COMMENTS]);
  Reg_WriteColor('KeywordColor',cc_color[CC_KEYWORD]);
  Reg_WriteColor('CommandColor',cc_color[CC_COMMAND]);
  Reg_WriteColor('ConstantColor',cc_color[CC_CONSTANT]);
  Reg_WriteColor('DefineColor',cc_color[CC_DEFINE]);
  Reg_WriteColor('DefineKeywordColor',cc_color[CC_DEFINEKEY]);
  Reg_WriteColor('DefineCommandColor',cc_color[CC_DEFINECOM]);
  Reg_WriteColor('DefineConstantColor',cc_color[CC_DEFINECONST]);
  Reg_WriteColor('FieldColor',cc_color[CC_FIELD]);

  Reg_WriteStyle('NormalStyle',cc_style[CC_NORMAL]);
  Reg_WriteStyle('CommentStyle',cc_style[CC_COMMENTS]);
  Reg_WriteStyle('KeywordStyle',cc_style[CC_KEYWORD]);
  Reg_WriteStyle('CommandStyle',cc_style[CC_COMMAND]);
  Reg_WriteStyle('ConstantStyle',cc_style[CC_CONSTANT]);
  Reg_WriteStyle('DefineStyle',cc_style[CC_DEFINE]);
  Reg_WriteStyle('DefineKeywordStyle',cc_style[CC_DEFINEKEY]);
  Reg_WriteStyle('DefineCommandStyle',cc_style[CC_DEFINECOM]);
  Reg_WriteStyle('DefineConstantStyle',cc_style[CC_DEFINECONST]);
  Reg_WriteStyle('FieldStyle',cc_style[CC_FIELD]);

  Reg_CloseKey;
end;

procedure ResetColorValues;
{Resets the color values to default}
begin
  Reg_DeleteKey('Colors');
  LoadColorValues;
end;

procedure LoadStartupValues;
{Loads the startup values from the registry}
begin
  Reg_OpenKey('Startup');
  StartupAction := Reg_ReadInteger('StartupAction',SU_SHOWFORM);
  RCXType := Reg_ReadInteger('RCXType',SU_MINDSTORMS);
  COMPort := Reg_ReadInteger('COMPort',0);
  Reg_CloseKey;
end;

procedure SaveStartupValues;
{Saves the startup values from the registry}
begin
  Reg_DeleteKey('Startup');
  Reg_OpenKey('Startup');
  Reg_WriteInteger('StartupAction',StartupAction);
  Reg_WriteInteger('RCXType',RCXType);
  Reg_WriteInteger('COMPort',COMPort);
  Reg_CloseKey;
end;

procedure ResetStartupValues;
{Resets the startup values to default}
begin
  Reg_DeleteKey('Startup');
  LoadStartupValues;
end;

procedure LoadGeneralValues;
{Loads the general values from the registry}
begin
  Reg_OpenKey('General');
  ShowRecent := Reg_ReadBool('ShowRecent',true);
  SaveBackup := Reg_ReadBool('SaveBackup',true);
  SaveWindowPos := Reg_ReadBool('SaveWindowPos',true);
  ShowToolbar := Reg_ReadBool('ShowToolbar',true);
  ShowStatusbar := Reg_ReadBool('ShowStatusbar',true);
  CompatibilityMode := Reg_ReadBool('CompatibilityMode',false);
  Reg_CloseKey;
end;

procedure SaveGeneralValues;
{Saves the general values to the registry}
begin
  Reg_DeleteKey('General');
  Reg_OpenKey('General');
  Reg_WriteBool('ShowRecent',ShowRecent);
  Reg_WriteBool('SaveBackup',SaveBackup);
  Reg_WriteBool('SaveWindowPos',SaveWindowPos);
  Reg_WriteBool('ShowToolbar',ShowToolbar);
  Reg_WriteBool('ShowStatusbar',ShowStatusbar);
  Reg_WriteBool('CompatibilityMode',CompatibilityMode);
  Reg_CloseKey;
end;

procedure ResetGeneralValues;
{Resets the general values to default}
begin
  Reg_DeleteKey('General');
  LoadGeneralValues;
end;

procedure LoadEditorValues;
{Loads the editor values from the registry}
begin
  Reg_OpenKey('Editor');
  ColorCoding := Reg_ReadBool('ColorCoding',true);
  ShowConstructForm := Reg_ReadBool('ShowConstructForm',true);
  ShowConstructPopup := Reg_ReadBool('ShowConstructPopup',false);
  FontName := Reg_ReadString('FontName','Courier New');
  FontSize := Reg_ReadInteger('FontSize',9);
  AutoIndentCode := Reg_ReadBool('AutoIndentCode',true);
  MacrosOn := Reg_ReadBool('MacrosOn',false);
  Reg_CloseKey;
end;

procedure SaveEditorValues;
{Saves the editor values to the registry}
begin
  Reg_DeleteKey('Editor');
  Reg_OpenKey('Editor');
  Reg_WriteBool('ColorCoding',ColorCoding);
  Reg_WriteBool('ShowConstructForm',ShowConstructForm);
  Reg_WriteBool('ShowConstructPopup',ShowConstructPopup);
  Reg_WriteString('FontName',FontName);
  Reg_WriteInteger('FontSize',FontSize);
  Reg_WriteBool('AutoIndentCode',AutoIndentCode);
  Reg_WriteBool('MacrosOn',MacrosOn);
  Reg_CloseKey;
end;

procedure ResetEditorValues;
{Resets the editor values to default}
begin
  Reg_DeleteKey('Editor');
  LoadEditorValues;
end;

procedure LoadAllValues;
begin
  LoadGeneralValues;
  LoadEditorValues;
  LoadStartupValues;
  LoadColorValues;
  LoadJoystickValues;
  LoadRecentValues;
  LoadWindowsValues;
  LoadKeywordValues;
  LoadConstructionValues;
  LoadMacroValues;
end;

procedure SaveAllValues;
begin
  SaveGeneralValues;
  SaveEditorValues;
  SaveStartupValues;
  SaveColorValues;
  SaveJoystickValues;
  SaveRecentValues;
  SaveWindowsValues;
  SaveKeywordValues;
  SaveConstructionValues;
  SaveMacroValues;
end;

procedure ResetAllValues;
begin
  ResetGeneralValues;
  ResetEditorValues;
  ResetStartupValues;
  ResetColorValues;
  ResetJoystickValues;
  ResetRecentValues;
  ResetWindowsValues;
  ResetKeywordValues;
  ResetConstructionValues;
  ResetMacroValues;
end;






{********************************************
 Handling the preferences form
 ********************************************}

var OldShowRecent:boolean;   // For saving the old version

procedure RememberGeneralValues;
{Remember current settings such that we know whether changed}
begin
  OldShowRecent := ShowRecent;
end;

procedure GetGeneralValues;
{Gets the values from the form}
begin
  ShowRecent := PrefForm.CheckShowRecent.Checked;
  ShowRecentChanged := (ShowRecent <> OldShowRecent);
  SaveWindowPos := PrefForm.CheckSavePos.Checked;
  SaveBackup := PrefForm.CheckSaveBackup.Checked;
  ShowToolbar := PrefForm.CheckShowToolbar.Checked;
  ShowStatusbar := PrefForm.CheckShowStatusbar.Checked;
  CompatibilityMode := PrefForm.CheckCompatibility.Checked;
end;

procedure DisplayGeneralValues;
{Displays the values in the form}
begin
  PrefForm.CheckShowRecent.Checked := ShowRecent;
  PrefForm.CheckSavePos.Checked := SaveWindowPos;
  PrefForm.CheckSaveBackup.Checked := SaveBackup;
  PrefForm.CheckShowToolbar.Checked := ShowToolbar;
  PrefForm.CheckShowStatusbar.Checked := ShowStatusbar;
  PrefForm.CheckCompatibility.Checked := CompatibilityMode;
end;

{The Editor Information}

var OldColorCoding:boolean;  // For saving the old version
    OldFontName:string;
    OldFontSize:integer;

procedure RememberEditorValues;
{Remember current settings such that we know whether changed}
begin
  OldColorCoding := ColorCoding;
  OldFontName := FontName;
  OldFontSize := FontSize;
end;

procedure GetEditorValues;
{Gets the values from the form}
begin
  ColorCoding := PrefForm.CheckColorCoding.Checked;
  ColorCodingChanged := (ColorCoding <> OldColorCoding);
  ShowConstructPopup := PrefForm.CheckShowConstructions.Checked;
  FontChanged := (FontName <> OldFontName) or (FontSize <> OldFontSize);
  AutoIndentCode := PrefForm.CheckAutoIndentCode.Checked;
  MacrosOn := PrefForm.CheckMacrosOn.Checked;
end;

procedure DisplayEditorValues;
{Displays the values in the form}
begin
  PrefForm.CheckColorCoding.Checked := ColorCoding;
  PrefForm.CheckShowConstructions.Checked := ShowConstructPopup;
  PrefForm.CheckAutoIndentCode.Checked := AutoIndentCode;
  PrefForm.CheckMacrosOn.Checked := MacrosOn;
end;

{ The Startup Information}

procedure RememberStartupValues;
{Remember current settings such that we know whether changed}
begin
  {Nothing to be done yet}
end;

procedure GetStartupValues;
{Gets the values from the form}
begin
  if prefForm.CheckShowForm.Checked then StartupAction := SU_SHOWFORM;
  if prefForm.CheckConnect.Checked then StartupAction := SU_CONNECT;
  if prefForm.CheckNoConnect.Checked then StartupAction := SU_NOCONNECT;

  if prefForm.CheckMindStorms.Checked then RCXType := SU_MINDSTORMS;
  if prefForm.CheckCyberMaster.Checked then RCXType := SU_CYBERMASTER;

  if prefForm.CheckAutomatic.Checked then COMPort := 0;
  if prefForm.CheckCOM1.Checked then COMPort := 1;
  if prefForm.CheckCOM2.Checked then COMPort := 2;
  if prefForm.CheckCOM3.Checked then COMPort := 3;
  if prefForm.CheckCOM4.Checked then COMPort := 4;
end;

procedure DisplayStartupValues;
{Display the values in the form}
begin
  prefForm.CheckShowForm.Checked := (StartupAction = SU_SHOWFORM);
  prefForm.CheckConnect.Checked := (StartupAction = SU_CONNECT);
  prefForm.CheckNoConnect.Checked := (StartupAction = SU_NOCONNECT);

  PrefForm.ComBox.Visible := prefForm.CheckConnect.Checked;

  prefForm.CheckMindStorms.Checked := (RCXType = SU_MINDSTORMS);
  prefForm.CheckCyberMaster.Checked := (RCXType = SU_CYBERMASTER);

  prefForm.CheckAutomatic.Checked := (COMPort = 0);
  prefForm.CheckCOM1.Checked := (COMPort = 1);
  prefForm.CheckCOM2.Checked := (COMPort = 2);
  prefForm.CheckCOM3.Checked := (COMPort = 3);
  prefForm.CheckCOM4.Checked := (COMPort = 4);
end;

{The Templates Information}

procedure RememberTemplateValues;
{Remember current settings such that we know whether changed}
begin
  // Nothing to be done
end;

procedure GetTemplateValues;
{Gets the values from the form}
var i:integer;
begin
  ConstructionsChanged := false;
  for i:=0 to PrefForm.TemplatesList.Items.Count-1 do
  begin
    if PrefForm.TemplatesList.Items[i] <> constructions[i+1] then
    begin
      ConstructionsChanged := true;
      constructions[i+1] := PrefForm.TemplatesList.Items[i];
    end
  end;
  constructnumb := PrefForm.TemplatesList.Items.Count;
end;

procedure DisplayTemplateValues;
{Displays the values in the form}
var i:integer;
begin
  PrefForm.TemplatesList.Items.Clear;
  for i:= 1 to constructnumb do
    PrefForm.TemplatesList.Items.Add(constructions[i]);
  PrefForm.TemplatesList.ItemIndex:=0;
end;

{The Macros Information}

procedure RememberMacroValues;
{Remember current settings such that we know whether changed}
begin
  // Nothing to be done
end;

procedure GetMacroValues;
{Gets the values from the form}
var i:integer;
    str:string;
begin
  MacrosChanged := false;
  macronumb:=0;
  for i:=0 to PrefForm.MacrosList.Items.Count-1 do
  begin
    str:='<Ctrl><Alt>';
    str:=str+ PrefForm.MacrosList.Items[i][1]+':';
    str:=str+Copy(PrefForm.MacrosList.Items[i],4,1000);
    if (Length(str)>13) then
    begin
      macronumb:=macronumb+1;
      if (str <> macros[macronumb]) then MacrosChanged := true;
      macros[macronumb] := str;
    end
  end;
  for i:=0 to PrefForm.ShiftMacrosList.Items.Count-1 do
  begin
    str:='<Ctrl><Alt><Shift>';
    str:=str+ PrefForm.ShiftMacrosList.Items[i][1]+':';
    str:=str+Copy(PrefForm.ShiftMacrosList.Items[i],4,1000);
    if (Length(str)>20) then
    begin
      macronumb:=macronumb+1;
      if (str <> macros[macronumb]) then MacrosChanged := true;
      macros[macronumb] := str;
    end
  end;
end;

procedure DisplayMacroValues;
{Displays the values in the form}
var i,numb:integer;
begin
  PrefForm.MacrosList.Items.Clear;
  PrefForm.ShiftMacrosList.Items.Clear;
  for i:=1 to 26 do PrefForm.MacrosList.Items.Add(Chr(Ord('A')+i-1)+': ');
  for i:=1 to 10 do PrefForm.MacrosList.Items.Add(Chr(Ord('0')+i-1)+': ');
  for i:=1 to 26 do PrefForm.ShiftMacrosList.Items.Add(Chr(Ord('A')+i-1)+': ');
  for i:=1 to 10 do PrefForm.ShiftMacrosList.Items.Add(Chr(Ord('0')+i-1)+': ');
  for i:= 1 to macronumb do
  begin
    if Pos('<Shift>',macros[i]) = 12 then
    begin
      numb:=Ord(macros[i][19])-Ord('A');
      if (numb<0) or (numb>25) then numb:=Ord(macros[i][19])-Ord('0')+26;
      PrefForm.ShiftMacrosList.Items[numb] := macros[i][19]+': '+ Copy(macros[i],21,1000);
    end else begin
      numb:=Ord(macros[i][12])-Ord('A');
      if (numb<0) or (numb>25) then numb:=Ord(macros[i][12])-Ord('0')+26;
      PrefForm.MacrosList.Items[numb] := macros[i][12]+': '+ Copy(macros[i],14,1000);
    end;
  end;
  PrefForm.MacrosList.ItemIndex:=0;
  PrefForm.ShiftMacrosList.ItemIndex:=0;
  PrefForm.MacrosList.Visible:=true;
  PrefForm.ShiftMacrosList.Visible:=false;
  PrefForm.MShift.Checked := false;
end;


{Handling the Events}

procedure TPrefForm.StartupDefaultClick(Sender: TObject);
begin
  ResetStartupValues;
  DisplayStartupValues;
end;

procedure TPrefForm.CheckConnectClick(Sender: TObject);
begin
  ComBox.Visible := CheckConnect.Checked;
end;

procedure TPrefForm.GeneralDefaultClick(Sender: TObject);
begin
  ResetGeneralValues;
  DisplayGeneralValues;
end;

procedure TPrefForm.EditorDefaultClick(Sender: TObject);
begin
  ResetEditorValues;
  DisplayEditorValues;
end;

procedure TPrefForm.FontBtnClick(Sender: TObject);
begin
  FontDialog1.Font.Name := FontName;
  FontDialog1.Font.Size := FontSize;
  if FontDialog1.Execute() then
  begin
    FontName := FontDialog1.Font.Name;
    FontSize := FontDialog1.Font.Size;
  end;
end;

procedure TPrefForm.TemplatesDefaultClick(Sender: TObject);
begin
  ResetConstructionValues;
  DisplayTemplateValues;
end;

procedure TPrefForm.UpBtnClick(Sender: TObject);
begin
  if PrefForm.TemplatesList.ItemIndex <= 0 then Exit;
  PrefForm.TemplatesList.Items.Exchange(
      PrefForm.TemplatesList.ItemIndex-1,
      PrefForm.TemplatesList.ItemIndex);
  PrefForm.TemplatesList.ItemIndex:=PrefForm.TemplatesList.ItemIndex-1;
end;

procedure TPrefForm.DownBtnClick(Sender: TObject);
begin
  if PrefForm.TemplatesList.ItemIndex < 0 then Exit;
  if PrefForm.TemplatesList.ItemIndex = PrefForm.TemplatesList.Items.Count-1 then Exit;
  PrefForm.TemplatesList.Items.Exchange(
      PrefForm.TemplatesList.ItemIndex,
      PrefForm.TemplatesList.ItemIndex+1);
  PrefForm.TemplatesList.ItemIndex:=PrefForm.TemplatesList.ItemIndex+1;
end;

procedure TPrefForm.InsertBtnClick(Sender: TObject);
var str:string;
begin
  if PrefForm.TemplatesList.ItemIndex < 0 then Exit;
  str := InputBox('Inserting a Template',
                  'Type the template you want to insert:',
                  '');
  if str<>'' then
    PrefForm.TemplatesList.Items.Insert(PrefForm.TemplatesList.ItemIndex,str);
end;

procedure TPrefForm.ChangeBtnClick(Sender: TObject);
var str:string;
begin
  if PrefForm.TemplatesList.ItemIndex < 0 then Exit;
  str := InputBox('Changing a Template',
                  'Change the Template:',
                  PrefForm.TemplatesList.Items[PrefForm.TemplatesList.ItemIndex]);
  PrefForm.TemplatesList.Items[PrefForm.TemplatesList.ItemIndex]:=str;
end;

procedure TPrefForm.DeleteBtnClick(Sender: TObject);
var ttt:integer;
begin
  ttt:= PrefForm.TemplatesList.ItemIndex;
  if ttt < 0 then Exit;
  PrefForm.TemplatesList.Items.Delete(ttt);
  if ttt< PrefForm.TemplatesList.Items.Count-1 then
    PrefForm.TemplatesList.ItemIndex:=ttt
  else
    PrefForm.TemplatesList.ItemIndex:=ttt-1;
end;

procedure TPrefForm.TemplatesListDblClick(Sender: TObject);
begin
  ChangeBtnClick(Self);
end;

procedure TPrefForm.MacrosDefaultClick(Sender: TObject);
begin
  ResetMacroValues;
  DisplayMacroValues;
end;

procedure TPrefForm.MShiftClick(Sender: TObject);
var lb:TListBox;
begin
  MacrosList.Visible:= not MShift.Checked;
  ShiftMacrosList.Visible:= MShift.Checked;
  if MShift.Checked then lb:=ShiftMacrosList else lb := MacrosList;
  lb.SetFocus;
end;

procedure TPrefForm.MDeleteClick(Sender: TObject);
var lb:TListBox;
begin
  if MShift.Checked then lb:=ShiftMacrosList else lb := MacrosList;
  lb.Items[lb.ItemIndex] := Copy(lb.Items[lb.ItemIndex],1,3);
  lb.SetFocus;
end;

procedure TPrefForm.MChangeClick(Sender: TObject);
var str:string;
    lb:TListBox;
begin
  if MShift.Checked then lb:=ShiftMacrosList else lb := MacrosList;
  str := InputBox('Changing a Macro',
                  'Change Macro '+ lb.Items[lb.ItemIndex][1]+':',
                  Copy(lb.Items[lb.ItemIndex],4,1000));
  MDeleteClick(Self);
  lb.Items[lb.ItemIndex]:=lb.Items[lb.ItemIndex]+str;
  lb.SetFocus;
end;

procedure TPrefForm.ShiftMacrosListDblClick(Sender: TObject);
begin
  MChangeClick(Self);
end;

procedure TPrefForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if ModalResult <> mrCancel then
  begin
    GetGeneralValues;
    GetEditorValues;
    GetStartupValues;
    GetTemplateValues;
    GetMacroValues;
  end;
end;

procedure TPrefForm.FormShow(Sender: TObject);
begin
  RememberGeneralValues;
  DisplayGeneralValues;
  RememberEditorValues;
  DisplayEditorValues;
  RememberStartupValues;
  DisplayStartupValues;
  RememberTemplateValues;
  DisplayTemplateValues;
  RememberMacroValues;
  DisplayMacroValues;
end;

procedure TPrefForm.FormCreate(Sender: TObject);
begin
  {Create the Registry}
  Reg_Init;
  {Load the settings}
  LoadAllValues;
end;

procedure TPrefForm.FormDestroy(Sender: TObject);
begin
  SaveAllValues;
end;


end.
