unit SearchRCX;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TSearchRCXForm = class(TForm)
    Label1: TLabel;
    OKBtn: TButton;
    CancelBtn: TButton;
    Panel1: TPanel;
    AutomaticBtn: TRadioButton;
    COM1Btn: TRadioButton;
    COM2Btn: TRadioButton;
    COM3Btn: TRadioButton;
    COM4Btn: TRadioButton;
    Panel2: TPanel;
    MindStormsBtn: TRadioButton;
    CyberMasterBtn: TRadioButton;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SearchRCXForm: TSearchRCXForm;

procedure SearchForRCX(atstartup:boolean);

function CheckAlive:boolean; //Checks whether the RCX is still alive

var
  IRexists:boolean;          // Whether the COM port exists
  RCXalive:boolean;          // Whether the RCX exists
  IsMindStorms:boolean;      // Whether the RCX is a MindStorms

implementation

{$R *.DFM}

uses MainUnit,Preferences;

function CheckAlive:boolean;
{Checks whether the RCX is (still) alive}
begin
  CheckAlive := false;
  RCXAlive := false;
  while true do
  begin
    if MainForm.RCX.PBAliveOrNot then
      break
    else if MessageDlg('Cannot find RCX. Switch it on or move it closer and press OK.',
                    mtWarning, [mbOK, mbCancel], 0) = mrCancel then
      exit;
  end;
  CheckAlive:=true;
  RCXAlive:=true;
end;

procedure SetRCXType(thetype:integer);
{Sets the type of the RCX}
begin
  if thetype = SU_MINDSTORMS then
  begin
    IsMindStorms := true;
    MainForm.RCX.PBrick := 1;
    MainForm.RCX.LinkType := 0;
  end else begin
    IsMindStorms := false;
    MainForm.RCX.PBrick := 0;
    MainForm.RCX.LinkType := 2;
  end;
end;

function FindPort(theport:integer):boolean;
{Searches for the COM port}
var i,pmin,pmax:integer;
begin
  IRexists:=false;
  if theport = 0 then
    begin pmin:=1; pmax:=4; end
  else
    begin pmin:=theport; pmax:=theport; end;
  for i:=pmin to pmax do
  begin
    MainForm.RCX.ComPortNo := i;
    if MainForm.RCX.InitComm() and  MainForm.RCX.TowerAndCableConnected()then
      begin IRexists:=true; break; end;
  end;
  FindPort := IRexists;
end;

function FindIt(thetype,theport:integer):boolean;
{Does the actual searching}
begin
  SetRCXType(thetype);
  FindPort(theport);
  RCXAlive := false;
  {If it exists, find the RCX}
  if IRexists then
    FindIt := CheckAlive
  else
    FindIt := false;
  if (not IsMindStorms) and RCXAlive then
// No idea what this is for????
end;

procedure SearchForRCX(atstartup:boolean);
{Tries to locate the RCX. atstartup indicates whether this is the
 call at startup, in which case we use the startup defaults.}
 var thetype,portnum:integer;
begin
  IRexists:=false;
  RCXalive:=false;
  IsMindStorms := true;
  if (atstartup and (StartupAction = SU_NOCONNECT)) then Exit;
  if (atstartup and (StartupAction = SU_CONNECT)) then
  begin
    if FindIt(RCXType,COMPort) then Exit;
  end;
  if SearchRCXForm.ShowModal = mrCancel then Exit;
  if SearchRCXForm.AutomaticBtn.Checked then portnum := 0;
  if SearchRCXForm.COM1Btn.Checked then portnum := 1;
  if SearchRCXForm.COM2Btn.Checked then portnum := 2;
  if SearchRCXForm.COM3Btn.Checked then portnum := 3;
  if SearchRCXForm.COM4Btn.Checked then portnum := 4;
  if SearchRCXForm.MindStormsBtn.Checked then thetype := SU_MINDSTORMS;
  if SearchRCXForm.CyberMasterBtn.Checked then thetype := SU_CYBERMASTER;
  FindIt(thetype,portnum);
end;

end.
