unit TransmitUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OleCtrls, SPIRITLib_TLB, ExtCtrls;

type
  TTransmitForm = class(TForm)
    TransmitMemo: TMemo;
    Timer1: TTimer;
    GroupBox1: TGroupBox;
    ImmediateRetries: TEdit;
    DownloadRetries: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SetRetriesChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TransmitForm: TTransmitForm;

implementation

uses MainUnit, Preferences;

{$R *.DFM}

procedure TTransmitForm.Timer1Timer(Sender: TObject);
var stsdata,stldata:OLEVariant;
    i:integer;
    str:string;
begin
  stsdata := MainForm.RCX.GetShortTermRetransStatistics();
  stldata := MainForm.RCX.GetLongTermRetransmitStatistics();
  TransmitMemo.Lines.BeginUpdate;
  TransmitMemo.Lines.Clear;
  TransmitMemo.Lines.Add('          Recent |    Total   ');
  TransmitMemo.Lines.Add('-----------------|------------');
  for i:=0 to 11 do
  begin
    if i=0 then
      str:='Total:'
    else if i = 1 then
      str:='  OK :'
    else
      str:=Format('%2d RT:',[i-1]);
    str := str+ Format('%5d%5d |%5d%5d',[
                  Integer(stsdata[0,i]),
                  Integer(stsdata[1,i]),
                  Integer(stldata[0,i]),
                  Integer(stldata[1,i])]);
    TransmitMemo.Lines.Add(str);
  end;
  TransmitMemo.SelStart:=0;
  TransmitMemo.Lines.EndUpdate;
end;

procedure TTransmitForm.FormShow(Sender: TObject);
begin
  Timer1.Enabled:=true;
end;

procedure TTransmitForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Timer1.Enabled := false;
end;

procedure TTransmitForm.SetRetriesChange(Sender: TObject);
begin
  MainForm.RCX.SetRetransmitRetries(
      StrToIntDef(ImmediateRetries.Text,0),
      StrToIntDef(DownloadRetries.Text,0));
end;

end.
