unit Watch;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type
  TWatchForm = class(TForm)
    VarBox: TGroupBox;
    TimerBox: TGroupBox;
    CheckTimer0: TCheckBox;
    ValueTimer0: TEdit;
    CheckTimer1: TCheckBox;
    ValueTImer1: TEdit;
    CheckTimer2: TCheckBox;
    ValueTimer2: TEdit;
    PollNow: TButton;
    ValueTimer3: TEdit;
    CheckTimer3: TCheckBox;
    VVar0: TEdit;
    CVar0: TCheckBox;
    CVar1: TCheckBox;
    VVar1: TEdit;
    CVar2: TCheckBox;
    VVar2: TEdit;
    VVar3: TEdit;
    CVar3: TCheckBox;
    CVar4: TCheckBox;
    VVar4: TEdit;
    CVar5: TCheckBox;
    VVar5: TEdit;
    VVar6: TEdit;
    CVar6: TCheckBox;
    CVar7: TCheckBox;
    VVar7: TEdit;
    CVar8: TCheckBox;
    VVar8: TEdit;
    VVar9: TEdit;
    CVar9: TCheckBox;
    CVar10: TCheckBox;
    VVar10: TEdit;
    CVar11: TCheckBox;
    VVar11: TEdit;
    VVar12: TEdit;
    CVar12: TCheckBox;
    CVar13: TCheckBox;
    VVar13: TEdit;
    CVar14: TCheckBox;
    VVar14: TEdit;
    VVar15: TEdit;
    CVar15: TCheckBox;
    VVar16: TEdit;
    CVar16: TCheckBox;
    CVar17: TCheckBox;
    VVar17: TEdit;
    CVar18: TCheckBox;
    VVar18: TEdit;
    VVar19: TEdit;
    CVar19: TCheckBox;
    CVar20: TCheckBox;
    VVar20: TEdit;
    CVar21: TCheckBox;
    VVar21: TEdit;
    VVar22: TEdit;
    CVar22: TCheckBox;
    CVar23: TCheckBox;
    VVar23: TEdit;
    VVar24: TEdit;
    CVar24: TCheckBox;
    CVar25: TCheckBox;
    VVar25: TEdit;
    CVar26: TCheckBox;
    VVar26: TEdit;
    VVar27: TEdit;
    CVar27: TCheckBox;
    CVar28: TCheckBox;
    VVar28: TEdit;
    CVar29: TCheckBox;
    VVar29: TEdit;
    VVar30: TEdit;
    CVar30: TCheckBox;
    CVar31: TCheckBox;
    VVar31: TEdit;
    MotorBox: TGroupBox;
    CheckMotorA: TCheckBox;
    ValueMotorA: TEdit;
    CheckMotorB: TCheckBox;
    ValueMotorB: TEdit;
    CheckMotorC: TCheckBox;
    ValueMotorC: TEdit;
    SensorBox: TGroupBox;
    CheckSensor1: TCheckBox;
    ValueSensor1: TEdit;
    CheckSensor2: TCheckBox;
    ValueSensor2: TEdit;
    CheckSensor3: TCheckBox;
    ValueSensor3: TEdit;
    MessageBox: TGroupBox;
    CheckMessage: TCheckBox;
    ValueMessage: TEdit;
    CheckAllBtn: TButton;
    CheckNoneBtn: TButton;
    PollRegularBtn: TSpeedButton;
    TimeBox: TComboBox;
    Timer1: TTimer;
    TachoBox: TGroupBox;
    CheckTCounter: TCheckBox;
    ValueTCounter: TEdit;
    CheckTSpeed: TCheckBox;
    ValueTSpeed: TEdit;
    CheckMCurrent: TCheckBox;
    ValueMCurrent: TEdit;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PollNowClick(Sender: TObject);
    procedure CheckAllBtnClick(Sender: TObject);
    procedure CheckNoneBtnClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure PollRegularBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TimeBoxChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  WatchForm: TWatchForm;

implementation

{$R *.DFM}

uses MainUnit,SearchRCX;

function GetMotorData(numb:integer):string;
var ttt:integer;
    str:string;
begin
  ttt:= MainForm.RCX.Poll(3,numb);
  str:='';
  if ttt div 128 = 1 then str:=str+' On ' else str:=str+'Off ';
  if (ttt mod 128) div 64 = 1 then str:=str+'Brake ' else str:=str+'Float ';
  if (ttt mod 16) div 8 = 1 then str:=str+'Fwd ' else str:=str+'Rev ';
  str:=str+Format('  %d', [ttt mod 8]);
  GetMotorData := str;
end;

var busy:boolean = false;

procedure TWatchForm.PollNowClick(Sender: TObject);
var i:integer;
begin
  if busy then exit;     // Avoid polling while polling
  busy:=true;
  try
    for i:=0 to 31 do
      if TCheckBox(FindComponent(Format('CVar%d',[i]))).Checked then
        TEdit(FindComponent(Format('VVar%d',[i]))).Text :=
                           Format('%6d',[MainForm.RCX.Poll(0,i)]);

    if CheckSensor1.Checked then
      ValueSensor1.Text := Format('%6d',[MainForm.RCX.Poll(9,0)]);
    if CheckSensor2.Checked then
      ValueSensor2.Text := Format('%6d',[MainForm.RCX.Poll(9,1)]);
    if CheckSensor3.Checked then
      ValueSensor3.Text := Format('%6d',[MainForm.RCX.Poll(9,2)]);

    if CheckMotorA.Checked then
      ValueMotorA.Text := GetMotorData(0);
    if CheckMotorB.Checked then
      ValueMotorB.Text := GetMotorData(1);
    if CheckMotorC.Checked then
      ValueMotorC.Text := GetMotorData(2);

    if CheckTimer0.Checked then
      ValueTimer0.Text := Format('%6d',[MainForm.RCX.Poll(1,0)]);
    if CheckTimer1.Checked then
      ValueTimer1.Text := Format('%6d',[MainForm.RCX.Poll(1,1)]);
    if CheckTimer2.Checked then
      ValueTimer2.Text := Format('%6d',[MainForm.RCX.Poll(1,2)]);
    if CheckTimer3.Checked then
      ValueTimer3.Text := Format('%6d',[MainForm.RCX.Poll(1,3)]);

    if CheckMessage.Checked then
      ValueMessage.Text := Format('%6d',[MainForm.RCX.Poll(15,0)]);

    if CheckTCounter.Checked then
      ValueTCounter.Text := Format('L:%6d  R:%6d',
              [MainForm.RCX.Poll(5,0),MainForm.RCX.Poll(5,1)]);
    if CheckTSpeed.Checked then
      ValueTSpeed.Text := Format('L:%6d  R:%6d',
              [MainForm.RCX.Poll(6,0),MainForm.RCX.Poll(6,1)]);
    if CheckMCurrent.Checked then
      ValueMCurrent.Text := Format('%6d',[MainForm.RCX.Poll(7,2)]);
  except
    ShowMessage('Cannot find the RCX anymore');
    Timer1.Enabled := false;
    PollRegularBtn.Down := false;
    busy:=false;
    exit;
  end;
  busy:=false;
end;

procedure TWatchForm.CheckAllBtnClick(Sender: TObject);
var i: Integer;
    temp: TComponent;
begin
  for i := WatchForm.ComponentCount - 1 downto 0 do
  begin
    temp := WatchForm.Components[i];
    if (temp is TCheckBox) then TCheckBox(temp).Checked := true;
  end;
  if IsMindStorms then
  begin
    CheckTCounter.Checked := false;
    CheckTSpeed.Checked := false;
    CheckMCurrent.Checked := false;
  end else begin
    CheckMessage.Checked := false;
  end;
end;

procedure TWatchForm.CheckNoneBtnClick(Sender: TObject);
var i: Integer;
    temp: TComponent;
begin
  for i := WatchForm.ComponentCount - 1 downto 0 do
  begin
    temp := WatchForm.Components[i];
    if (temp is TCheckBox) then TCheckBox(temp).Checked := false;
  end;
end;

procedure TWatchForm.Timer1Timer(Sender: TObject);
begin
  PollNowClick(Self);
end;

procedure TWatchForm.PollRegularBtnClick(Sender: TObject);
begin
  Timer1.Enabled := PollRegularBtn.Down;
end;

procedure TWatchForm.FormShow(Sender: TObject);
begin
  PollRegularBtn.Down := false;
  Timer1.Enabled := false;
  busy := false;
  if IsMindStorms then
  begin
    MotorBox.Top := 88;
    TimerBox.Top := 168;
    VarBox.Height:=297;
    MessageBox.Visible:=true;
    TachoBox.Visible:=false;
    CheckTCounter.Checked := false;
    CheckTSpeed.Checked := false;
    CheckMCurrent.Checked := false;
   end else begin
    MotorBox.Top := 80;
    TimerBox.Top := 152;
    VarBox.Height:=305;
    MessageBox.Visible:=false;
    TachoBox.Visible:=true;
    CheckMessage.Checked := false;
  end;
end;

procedure TWatchForm.FormCreate(Sender: TObject);
begin
  TimeBox.ItemIndex := 3;
end;

procedure TWatchForm.TimeBoxChange(Sender: TObject);
begin
  case TimeBox.ItemIndex of
    0: Timer1.Interval := 100;
    1: Timer1.Interval := 200;
    2: Timer1.Interval := 500;
    3: Timer1.Interval := 1000;
    4: Timer1.Interval := 2000;
    5: Timer1.Interval := 5000;
    6: Timer1.Interval := 10000;
  end;
end;

procedure TWatchForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Timer1.Enabled := false;
end;

end.
